#ifndef KOMPLEX_KOMPLEX_H
#define KOMPLEX_KOMPLEX_H

#include <iostream>

class Komplex {
    double re;
    double im;

public:
    Komplex() {
        re = 0;
        im = 0;
    }

    Komplex(double _re, double _im = 0) {
        re = _re;
        im = _im;
    }

    double get_re() const {
        return re;
    }

    double get_im() const {
        return im;
    }

    double get_r() const;

    double get_fi() const;
};

std::ostream& operator<<(std::ostream& os, Komplex const& k);

Komplex operator+(Komplex const& c);
Komplex operator-(Komplex const& c);
Komplex operator+(Komplex const& lhs, Komplex const& rhs);
Komplex operator-(Komplex const& lhs, Komplex const& rhs);
Komplex operator*(Komplex const& lhs, Komplex const& rhs);
Komplex operator/(Komplex const& lhs, Komplex const& rhs);
Komplex& operator+=(Komplex& lhs, Komplex const& rhs);
Komplex& operator-=(Komplex& lhs, Komplex const& rhs);
Komplex& operator*=(Komplex& lhs, Komplex const& rhs);
Komplex& operator/=(Komplex& lhs, Komplex const& rhs);

bool operator==(Komplex const& lhs, Komplex const& rhs);
bool operator!=(Komplex const& lhs, Komplex const& rhs);

Komplex operator/(Komplex const& k, double d);

Komplex Komplex_sqrt(double d);
Komplex Komplex_from_r_fi(double r, double fi);

#endif //KOMPLEX_KOMPLEX_H
